<script lang="ts">
    import { crossfade } from 'svelte/transition'
    import { cubicOut, sineIn } from 'svelte/easing'
    import { flip } from 'svelte/animate'
    import ErrorToast from './Error.svelte'
    import SuccessToast from '../success/Success.svelte'
    import { errors } from './'
    import type { IdentifiedError } from './'
    import { success } from '$lib/success'

    const [send, receive] = crossfade({
        duration: 300,
        easing: cubicOut,
        fallback() {
            return {
                duration: 100,
                easing: sineIn,
                css: t => `opacity: ${t}`
            }
        }
    })

    const remove = (error: IdentifiedError) => {
        errors.update(list => list.filter(err => err !== error))
    }

    const removeSuccess = toast => {
        success.update(list => list.filter(succ => succ.id !== toast.id))
    }
</script>

<div id="error-stack" aria-live="assertive">
    <div class="stack-container">
        {#each $errors as error (error.id)}
            <span
                class="animated-container"
                in:receive={{ key: error.id }}
                out:send={{ key: error.id }}
                animate:flip={{ duration: 300 }}
            >
                <ErrorToast {error} on:click={() => remove(error)} />
            </span>
        {/each}
        {#each $success as succ (succ.id)}
            <span
                class="animated-container"
                in:receive={{ key: succ.id }}
                out:send={{ key: succ.id }}
                animate:flip={{ duration: 300 }}
            >
                <SuccessToast success={succ} on:click={() => removeSuccess(succ)} />
            </span>
        {/each}
    </div>
</div>

<style lang="postcss">
    #error-stack {
        @apply fixed inset-0 flex items-end px-4 py-6 pointer-events-none z-50 sm:p-6 sm:items-start;

        .stack-container {
            @apply w-full flex flex-col items-center sm:items-end;

            & > :global(*) + :global(*) {
                --tw-space-y-reverse: 0;
                margin-top: calc(1rem * calc(1 - var(--tw-space-y-reverse)));
                margin-bottom: calc(1rem * var(--tw-space-y-reverse));
            }

            .animated-container {
                @apply max-w-sm w-full;
            }
        }
    }
</style>
